--! old crappy menu code, too lazy to change..

local OPTION_TOGGLE = 0
local OPTION_SCROLL = 1

local options = {
    {name = "Star requirement", varToChange = "starRequirement", status = function () return gGlobalSyncTable.starRequirement end, optionType = OPTION_SCROLL},
    {name = "Randomize levels", varToChange = "randomizeLvl", status = function () return gGlobalSyncTable.randomizeLvl end, optionType = OPTION_TOGGLE},
    {name = "Randomize objects", varToChange = "randomizeObj", status = function () return gGlobalSyncTable.randomizeObj end, optionType = OPTION_TOGGLE},
}

local selectedOption = 1
local cooldown = 5
local cooldownCounter = 0
local menu = false

local function menu_controls()
    local stickY = gMarioStates[0].controller.stickY
    local stickX = gMarioStates[0].controller.stickX
    local isXheld = gMarioStates[0].controller.buttonDown & X_BUTTON ~= 0

    local option = options[selectedOption]

    gMarioStates[0].freeze = 1

    if gMarioStates[0].controller.buttonPressed & START_BUTTON ~= 0 or gMarioStates[0].controller.buttonPressed & B_BUTTON ~= 0 then
        menu = false
        play_sound(SOUND_GENERAL_PAINTING_EJECT, gMarioStates[0].pos)
    end

    if cooldownCounter > 0 then
        cooldownCounter = cooldownCounter - 1
    else
        if stickY > 0.5 then
            selectedOption = selectedOption - 1
            if selectedOption < 1 then
                selectedOption = #options
            end
            play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            cooldownCounter = cooldown
        elseif stickY < -0.5 then
            selectedOption = selectedOption + 1
            if selectedOption > #options then
                selectedOption = 1
            end
            play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            cooldownCounter = cooldown
        elseif gMarioStates[0].controller.buttonPressed & A_BUTTON ~= 0 and option.optionType == OPTION_TOGGLE then
            play_sound(SOUND_MENU_CLICK_FILE_SELECT, gMarioStates[0].pos)
            gGlobalSyncTable[option.varToChange] = not gGlobalSyncTable[option.varToChange]
            if option.func then
                option.func()
            end
        elseif option.optionType == OPTION_SCROLL then
            if stickX > 0.5 then
                if isXheld then
                    gGlobalSyncTable[option.varToChange] = gGlobalSyncTable[option.varToChange] + 10
                else
                    gGlobalSyncTable[option.varToChange] = gGlobalSyncTable[option.varToChange] + 1
                end
                play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
                cooldownCounter = cooldown
            elseif stickX < -0.5 then
                if isXheld then
                    gGlobalSyncTable[option.varToChange] = gGlobalSyncTable[option.varToChange] - 10
                else
                    gGlobalSyncTable[option.varToChange] = gGlobalSyncTable[option.varToChange] - 1
                end
                play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
                cooldownCounter = cooldown
            end

            if gGlobalSyncTable[option.varToChange] < 0 then
                gGlobalSyncTable[option.varToChange] = 0
            elseif gGlobalSyncTable[option.varToChange] > 182 then
                gGlobalSyncTable[option.varToChange] = 182
            end
        end
    end
end

function hud_render()
    if not menu then return end

    local screenWidth = djui_hud_get_screen_width()
    local screenHeight = djui_hud_get_screen_height()
    local menuY = 60
    local title = "RANDOMIZER V2"
    local titleX = (screenWidth * 0.5) - (djui_hud_measure_text(title) * 2)
    djui_hud_set_resolution(RESOLUTION_DJUI)
    djui_hud_set_font(FONT_TINY)
    djui_hud_set_color(0, 0, 255, 100)
    djui_hud_render_rect(0, 0, screenWidth, screenHeight)
    djui_hud_set_color(0, 0, 0, 255)
    djui_hud_print_text(title, titleX + 5, menuY + 25, 8)
    djui_hud_set_color(255, 255, 255, 255)
    djui_hud_print_text(title, titleX, menuY + 20, 8)
    menu_controls()
    local optionY = menuY + 300
    for i, option in ipairs(options) do
        local optionText = option.name
        local optionX = (screenWidth * 0.5) - (djui_hud_measure_text(optionText) * 2)
        if i == selectedOption then
            optionText = "> " .. optionText
        end
        djui_hud_set_color(0, 0, 0, 255)
        djui_hud_print_text(optionText, optionX + 3, optionY + 3, 4)
        if option.optionType == OPTION_TOGGLE then
            if option.status() then
                djui_hud_set_color(255, 255, 255, 255)
            else
                djui_hud_set_color(255, 100, 100, 255)
            end
        else
            djui_hud_set_color(255, 255, 255, 255)
        end
        djui_hud_print_text(optionText, optionX, optionY, 4)
        if option.optionType == OPTION_SCROLL then
            local statusText = "" .. option.status()
            local statusTextWidth = djui_hud_measure_text(statusText)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_print_text(statusText, optionX + (djui_hud_measure_text(option.name) * 5) + 3, optionY + 3, 4)
            djui_hud_set_color(255, 255, 255, 255)
            djui_hud_print_text(statusText, optionX + (djui_hud_measure_text(option.name) * 5), optionY, 4)
        end
        optionY = optionY + 65
    end
end

hook_event(HOOK_ON_HUD_RENDER, hud_render)

if network_is_server() then
    hook_chat_command("menu", "Opens the randomizer menu", function ()
        menu = not menu
        selectedOption = 1
        play_sound(SOUND_GENERAL_PAINTING_EJECT, gMarioStates[0].pos)
        return true
    end)
end